        SUBROUTINE PFILE_INFO
C
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *

        IMPLICIT NONE
C
        include '../include/allprogs.inc'
        INCLUDE '../include/info.inc'

        INCLUDE '../include/pifhead.inc'
        type (PIFHEAD_T) MAPHEAD, IMGHEAD
        COMMON /PIFHEAD/   MAPHEAD, IMGHEAD

C  Local
      INTEGER*4 IMGLUN, TEST, TEMP_UNITS, num_secs, total_views
      CHARACTER*(filename_len)  FNAME
      character*11 subname
      data subname /'PFILE_INFO'/


C------------------------------------------------------------------------------
C
        IMGLUN      = pix_file_unit 
        NFILES      = 0                  ! COUNT THE NUMBER OF PARAMETER FILES
        total_views = 0                  ! COUNT THE NUMBER OF IMAGES TO SEARCH
        BOX_OUT     = -1                 ! INITIALIZE MAXIMUM PARTICLE DIAMETER
        PIXSIZ_OUT  =  100000.0          ! INITIALIZE PIXSIZ_OUT
        PIXSIZ_MAX  = -100000.0          ! INITIALIZE PIXSIZ_MAX
C
  100   READ (*,'(A)',ERR=950,END=999) FNAME
C  *************************************************************
C  *  Open file and read first line, make sure it is not data  *
C  *************************************************************
        IF (FNAME(1:1) .eq. ' ') goto  955
        IF(NFILES.NE.0) CLOSE (UNIT=3)
        OPEN (UNIT=3, FILE=FNAME, STATUS='OLD', ERR=960,
     1     ACCESS='SEQUENTIAL', FORM='FORMATTED')
        NFILES = NFILES + 1
        IF(NFILES.GT.999) GO TO 940
        READ (3,'(A)',ERR=970) IMG_FNAMES(NFILES)
        READ (3, *, ERR=975) PIXSIZS(NFILES), TEMP_UNITS,
     1    VOLTS(NFILES), AMPFACS(NFILES), DELF_MAJS(NFILES),
     2    DELF_MINS(NFILES), ANG_MAJS(NFILES), CS_COEFFS(NFILES)
        IF(TEMP_UNITS.LT.1 .OR. TEMP_UNITS.GT.2) THEN
          call error_stop(progname,subname,
     +     '* Value for UNIT should be 1 or 2 in PARAM file *')
        ENDIF
C  **************************************************************
C  *   FOR PURPOSES OF CALCULATIONS WITHIN THIS PROGRAM         *
C  *    CONVERT ALL PIXEL SIZES TO SAME UNITS AS "units"    *
C  **************************************************************
        IF(TEMP_UNITS.NE.units) THEN
          IF(TEMP_UNITS.EQ.1) THEN
              PIXSIZS(NFILES) = PIXSIZS(NFILES) / 10.0          ! CONVERT TO NM
            ELSE
              PIXSIZS(NFILES) = PIXSIZS(NFILES) * 10.0    ! CONVERT TO ANGSTROMS
          ENDIF
        ENDIF
        PIXSIZ_OUT           = MIN(PIXSIZ_OUT,PIXSIZS(NFILES))
        PIXSIZ_MAX           = MAX(PIXSIZ_MAX,PIXSIZS(NFILES))
        PARAM_FNAMES(NFILES) = FNAME

C  ********************************************************************
C  *  Open IMAGE file and check size of each particle to determine    *
C  *   largest value of BOX_OUT.                                     *
C  *  Count particles in parameter file, find one with highest value  *
C  ********************************************************************
        IMGHEAD%LUNUM = IMGLUN
        CALL PIF_OPEN (IMG_FNAMES(NFILES), IMGHEAD%LUNUM, 'r')
        CALL PIF_READ_GH (IMGHEAD)
        npix_col  = IMGHEAD%NUMCOLS
        npix_row  = IMGHEAD%NUMROWS
        num_secs  = IMGHEAD%numSecs
        pixhd_endian  = IMGHEAD%endianNess
        pixhd_htyp    = IMGHEAD%htype
        pixhd_mode    = IMGHEAD%mode
        
        if (npix_col .NE. npix_row ) goto 980

        NBOX(NFILES) = npix_col
        BOX_OUT      = MAX(BOX_OUT, npix_col)

        TEST         = IMGHEAD%nimg
        NIDS(NFILES) = TEST
        total_views  = total_views + TEST 

        CALL PIF_CLOSE (IMGLUN)

        PRINT *, 'File #',NFILES,'Orient File: ',PARAM_FNAMES(NFILES)
        PRINT *, 'File #',NFILES,'Image  File: ', IMG_FNAMES(NFILES)
        PRINT *, 'VIEWS = ',  TEST,num_secs
        PRINT *, 'numCols = ', npix_col, 'numRows = ', npix_row
C  ****************************************************
C  *    HERE WHEN AT END OF CURRENT PARAMETER FILE    *
C  ****************************************************
        IF(TEST.EQ.0) goto 990 

        IF(NFILES.EQ.1) then
            MIN_NIDS = TEST
        else
            MIN_NIDS = min(MIN_NIDS,TEST)
        endif

        GO TO 100                       ! CHECK FOR ADDITIONAL PARAMETER FILES
C  ***************************************************************************
C  *    ERROR MESSAGES    *
C  ************************
  940   call error_stop(progname,subname,
     +    '* More than 999 parameter files: EXIT program *')
  950   call error_stop(progname,subname,
     +    '* Error reading parameter filename: EXIT program *')
  955   call error_stop(progname,subname,
     +    '* A blank parameter line: EXIT program *')
  960   call error_stop(progname,subname,
     +    '* Error opening parameter file: EXIT program *')
  970   call error_stop(progname,subname,
     +    '* Error reading IMAGE filename: EXIT program *')
  975   call error_stop(progname,subname,
     +    '* READ ERROR: 2nd record of PARAMETER file   *')
  990   call error_stop(progname,subname,
     +    ' * PARAM file contains no data: EXIT program *')
  980   call error_stop(progname,subname,
     +    ' * PARAM file npix_col != npix_row: EXIT program *')

  999   WRITE(*,'(I5,A,I6,A)') NFILES, ' PARAMETER files and total of',
     1   total_views , ' images for computation.'
        
        npix_row = BOX_OUT
        npix_col = BOX_OUT

        CLOSE (UNIT=3)
        RETURN
C
        END

